# -*- perl -*-
# TrackGuy / TG / Mail.pm
# $Id: TGMail.pm,v 1.1 2000/11/05 21:01:47 morimoto Exp $
use Jcode;
package TG::Mail;
use strict;

use vars qw($VERSION);
$VERSION = '1.00';

################################################################
# TGMail 饹Υ֥Ȥ򿷵롣
sub new{
    my $this = {};
    my $type = shift;
    my %params = @_;
    local($_);

    $this->{'To'} = $params{'To'};
    $this->{'Errors-To'} = $params{'Errors-To'} || $TG::errors_to;
    $this->{'Reply-To'} = $params{'Reply-To'};
    $this->{'CC'} = $params{'CC'};
    $this->{'From'} = $params{'From'} || $TG::default_from;
    $this->{'Charset'} = $params{'Charset'} || $TG::default_charset;
    $this->{'Subject'} = $params{'Subject'} || $TG::default_subject;
    $this->{'Subject'} = Jcode->new($this->{'Subject'})->jis->mime_encode;

    for(keys %params){
	if(/^X-/){
	    $this->{$_} = $params{$_};
	}
    }

    bless $this, $type;
    $this;
}

################################################################
# إåɲ
sub header{
    my $this = shift;
    my %params = @_;
    my $key;
    for $key(keys %params){
	$this->{$key} = $params{$key};
    }
}

################################################################
# (᥽å) ƤǤ֥᡼Фפȡ
# ºݤˤȯʤǡstdout  HTML  PRE ǽФ
sub fakemail{
    my $this = shift;
    $this->{'Fakemail'} = 1;
}

################################################################
# ᡼֤
sub compose{
    my $this = shift;
    my @buf;
    local($_);


    push @buf, "From: $this->{'From'}\n";
    push @buf, "To: $this->{'To'}\n";
    push @buf, "Subject: $this->{'Subject'}\n";
    push @buf, "Reply-To: $this->{'Reply-To'}\n"
	if length $this->{'Reply-To'};
    push @buf, "CC: $this->{'CC'}\n"
	if length $this->{'CC'};
    push @buf, "Errors-To: $this->{'Errors-To'}\n"
	if length $this->{'Errors-To'};
    push @buf, "Precedence: junk\n";
    push @buf, "Mime-Version: 1.0\n";
    push @buf, "X-Mailer: TrackGuy\n";

    for(sort keys %$this){
	if(/^X-/){
	    push @buf, "$_: $this->{$_}\n";
	}
    }

    push @buf, "Content-Type: text/plain; charset=$this->{Charset}\n";

    push @buf, "\n";
    push @buf, Jcode->new($this->{'Body'})->jis;
    push @buf, "\n";

    join('', @buf);
}

################################################################
# ᡼ʸԽ񤯥᥽åɡ
# Ūˤϡ᡼ʸˤʤ뤿ʸХåե˰ɲä
sub print{
    my $this = shift;
    $this->{'Body'} .= shift;
}

################################################################
# ᡼
sub send{
    my $this = shift;
    unless($this->{'Sent'}){
	my $mail = &compose($this);

	if($this->{'Fakemail'}){
	    print '<PRE><SMALL>';
	    print $mail;
	    print '</SMALL></PRE>';
	}else{
	    my $recipient = $this->{'To'} || $this->{'CC'};
	    open(SENDMAIL, "| $TG::mta $recipient");
	    print SENDMAIL $mail;
	    close(SENDMAIL);
	}
	$this->{'Sent'} = 1;
    }
}

################################################################
# TGMail ֥ȤΥǥȥ饯
# ǥȥ饯Ǥ send ᥽åɤ򥳡뤹ΤǡФ˺줬ʤ.
sub DESTROY{
    my $this = shift;
    &send($this);
}

1;

__END__

=head1 NAME

TGMail - Perl CGI ѥ᡼Х饹

=head1 SYNOPSIS

  use TGMail;
  my $m = TGMail->new('To' => 'webmaster@foo.co.jp',
                         'Subject' => 'Hi, webmaster!');
  $m->print('ʤȤȤ');

=head1 ABSTRACT

Υ饤֥, Perl CGI ץȤ, ܸΥ᡼
˻ȤȤǤ.

ޤ new ᥽åɤˤ, ᡼Ѥ TGMail 饹Υ֥Ȥ
.

֥ȤʤɤΥ᡼°, new ǥ֥Ȥ
Ȥ˻ꤷƤ. Ƥ°ɲä뤳Ȥ ϤǤʤ

, ֥ȤФ, print ᥽åɤȤä, ʸɤɤ
äƤ. ʸɲäȤʸ(饯å), Ĥޤ 
print ᥽åɤΰ, ҤƤ TGMail 饹ƤӽФ Perl 
Ȥ EUC ޤ JIS (iso-2022-jp) ǽ񤫤Ƥɬפ.  
ݤŻҥ᡼, ưŪ iso-2022-jp Ѵ.

TGMail ֥Ȥ, Ǥ, ʬޤ줿᡼Ƥ
ƤǤ.

=head1 DESCRIPTION

=head2 TGMail ֥Ȥκ

my $m = TGMail->new('To' => 'webmaster@foo.co.jp',
                       'Charset' => 'us-ascii');
                       'Subject' => 'Hello!');

Ȥä褦, new ᥽åɤΰ, ʣΥϥå, ᡼
ʤ°ꤹ. νʤ. Ǥ°ϰʲ
̤:

=item To

᡼ꤹ. To λϾάǤʤ.

=item Subject

֥Ȥꤹ. άΥǥեȤ $default_subject ѿ
.

=item From

᡼ȯԤꤹ. άΥǥեȤ $default_from ѿ
. ϥ᡼إå From: ( UNIX From) Ѥ.

=item Reply-To

Reply-To ꤹ. άǽ.

=item Errors-To

Errors-To ꤹ. άΥǥեȤ $errors_to ѿ.

=item Charset

᡼ܥǥΥ饯åȤꤹ. άΥǥեȤ 
$default_charset ѿ. ܸ򤵤ʤؤˤ 
us-ascii ʤɤꤹ٤Ǥ.

=item X-إå

X- ǤϤޤǤդ̾Υإå.

=head2 إåǤɲ

$m->header('X-Mailer' => 'FooMailer 1.2');

̵̾ϥåǻꤹ롣

=head2 ʸλ

$m->print(ʸ);

ʸ᡼ʸɲä. ƤǤ⹽ʤ. 缡ʸɲä
. 饯åȤ EUC ޤ iso-2022-jp Τ.

=head2 ᡼

TGMail ֥Ȥ, Ǥ, ʬޤ줿᡼Ƥ
ƤǤ. ä, ֥Ȥä, ʸɤɤ
ä, ȤäƤƤ褤. ξ᡼뤬Τ
֥ȾǤΥߥ󥰤ˤʤ뤫, 줬ޤʤΤۤ
¿

ŪԤʤˤ, send ᥽åɤѤ.

$m->send;

 send ᥽åɤԤʤ,  TGMail ֥Ȥϡ
ߡפȤ,  send ᥽åɤƤǤϹԤʤʤ.  ̵, 
Υ֥ȾǤκݤϹԤʤʤ.

=head2 ǥХåǽ

$m->fakemail;

fakemail ᥽åɤƤ֤, ᡼ϼºݤ줺, <PRE> ǰϤ
ɸϤ˽Ф뤿, CGI Script νϤȺä Web ֥饦̤˽
뤳ȤǤ.

=head1 BUGS

Υޥ˥奢 perldoc ǤϸʤΤ, ɤΤޤɤषޤ.

=head1 SEE ALSO

=cut
